"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _core = require("@astql/core");

var _defaultParserInterface = _interopRequireDefault(require("@astql/core/utils/defaultParserInterface"));

var _package = _interopRequireDefault(require("css-tree/package.json"));

var ID = 'csstree';

var _default = (0, _extends2["default"])({}, _defaultParserInterface["default"], {
  id: ID,
  displayName: ID,
  version: _package["default"].version,
  homepage: _package["default"].homepage || 'https://github.com/csstree/csstree',
  locationProps: new Set(['loc']),
  loadParser: function loadParser(callback) {
    (0, _core.multipleRequire)(['css-tree'], callback);
  },
  parse: function parse(csstree, code, options) {
    return csstree.toPlainObject(csstree.parse(code, (0, _extends2["default"])({
      positions: true
    }, options)));
  },
  nodeToRange: function nodeToRange(_ref) {
    var loc = _ref.loc;

    if (loc && loc.start && loc.end) {
      return [loc.start.offset, loc.end.offset];
    }
  },
  opensByDefault: function opensByDefault(node, key) {
    return key === 'children';
  },
  getDefaultOptions: function getDefaultOptions() {
    return {
      context: 'stylesheet',
      parseValue: true,
      parseRulePrelude: true,
      parseAtrulePrelude: true,
      parseCustomProperty: false
    };
  },
  _getSettingsConfiguration: function _getSettingsConfiguration() {
    return {
      fields: [['context', ['stylesheet', 'atrule', 'atrulePrelude', 'mediaQueryList', 'mediaQuery', 'rule', 'selectorList', 'selector', 'block', 'declarationList', 'declaration', 'value']], 'parseValue', 'parseRulePrelude', 'parseAtrulePrelude', 'parseCustomProperty']
    };
  }
});

exports["default"] = _default;